//
//  CameraDemoViewController.m
//  CameraDemo
//
//  Created by Chao-Hsin Shih on 8/30/10.
//  Copyright sjsu 2010. All rights reserved.
//

#import "CameraDemoViewController.h"
#import "LinesView.h"
//#import "EXF.h"
//#import "getLocationInfo.h"

@implementation CameraDemoViewController

@synthesize picker; //generate getter and setter
@synthesize locationManager; 
@synthesize latitudeLabel; 
@synthesize longitudeLabel;

//BOOL gLogging = FALSE;

-(void) doCancel{
	NSLog(@"doCancel");
}

-(void) doShutter{
	NSLog(@"doShutter");
	[picker takePicture];
	
}


- (void) viewDidAppear:(BOOL)animated{
	[super viewDidAppear:animated];
	
	//display camera if not already displayed
	if(picker == nil){
		picker = [[UIImagePickerController alloc] init];
		picker.delegate = self;
		picker.sourceType = UIImagePickerControllerSourceTypeCamera;
		//picker.allowsEditing = YES;
		
		
		//Determine size of overlay
		CGRect frame = picker.view.frame;
		NSLog(@"x: %1.0f, y: %1.0f, width: %1.0f, height: %1.0f",
			  frame.origin.x, frame.origin.y, frame.size.width, frame.size.height);
		
		
		//add a toolbar at the bottom of the view
		CGRect toolbarFrame = frame;
		toolbarFrame.origin.y = frame.size.height - 52;
		toolbarFrame.size.height = 52.0;
		UIToolbar *toolbar = [[UIToolbar alloc] initWithFrame:toolbarFrame];
		
		//cancel button
		UIBarButtonItem *itemCancel = 
		[[UIBarButtonItem alloc]initWithTitle:@"Cancel" style:UIBarButtonItemStyleBordered target:self action:@selector(doCancel)];
		
		//flexible space
		UIBarButtonItem *itemFlexSpace = 
		[[UIBarButtonItem alloc]initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil];
		
		//shutter camera button
		UIBarButtonItem *itemShutter =
		[[UIBarButtonItem alloc]initWithBarButtonSystemItem:UIBarButtonSystemItemCamera target:self action:@selector(doShutter)];
		
		//add buttons to toolbar
		NSArray *array = [[NSArray alloc] initWithObjects:itemCancel, itemFlexSpace, itemShutter, nil];
		toolbar.items = array;
		
		CGRect labelFrame = frame;

		CGRect accFrame = frame;
		accFrame.origin.y = 50;
		
		LinesView *myView = [[LinesView alloc] initWithFrame:frame];
		[myView addSubview:toolbar];
	
		
		latitudeLabel = [[UILabel alloc]initWithFrame:labelFrame];
		latitudeLabel.backgroundColor = [UIColor clearColor];
		latitudeLabel.opaque = YES;
		latitudeLabel.textColor = [UIColor whiteColor];
		[myView addSubview:latitudeLabel];
		
		
		longitudeLabel = [[UILabel alloc]initWithFrame:accFrame];
		longitudeLabel.backgroundColor = [UIColor clearColor];
		longitudeLabel.opaque = NO;
		longitudeLabel.textColor = [UIColor whiteColor];
		
		//[myView insertSubview:longitudeLabel];
		[myView addSubview:longitudeLabel];
		
		picker.showsCameraControls = NO;
		
		picker.cameraOverlayView = myView;
		[self presentModalViewController:picker animated:YES];
	}
}


-(void) imagePickerControllerDidCancel:(UIImagePickerController *)picker{
	//Dismiss the controller
	[self dismissModalViewControllerAnimated:YES];
}

-(void) imagePickerController:(UIImagePickerController *)picker 
didFinishPickingMediaWithInfo:(NSDictionary *)info{
	
	for(id key in info){
		
		//display key
		NSLog(@"key: %@", key);
		NSLog(@"Value: %@", [info valueForKey:key]);
		//display value for a given key
		//if([key isEqualToString:@"UIImagePickerControllerMediaType"])
		//	NSLog(@"Value: %@", [info valueForKey:key]);
		
		//display image size of original image

		if([key isEqualToString: @"UIImagePickerControllerOriginalImage"]){
			//NSData *image1 = [NSData dataWithContentsOfFile:@"/private/var/mobile/Media/DCIM/100APPLE/"];
			
			UIImage *image = [info valueForKey:key];
			NSLog(@"width: %1.0f, height: %1.0f", image.size.width, image.size.height);
			//save the image
//			UIImageWriteToSavedPhotosAlbum(image, nil, nil, nil);
			
			CLLocation *location = [[CLLocation alloc] init];
			//NSLog(@"images1 : %@", image1);
		//	NSData *image1 = [[NSData alloc] initWithData:[self geotagImage:image withLocation:location]];
			UIImageWriteToSavedPhotosAlbum(image, nil, nil, nil);
			//UIImageWriteToSavedPhotosAlbum(image, self, @selector(imageSavedToPhotosAlbum: didFinishSavingWithError: contextInfo:), context);  
//			NSData *image2 = [info valueForKey:key];
					
		}
	}
	
	//dismiss the controller
	[self dismissModalViewControllerAnimated:YES];
	 
}

- (void)imageSavedToPhotosAlbum:(UIImage *)image didFinishSavingWithError:(NSError *)error contextInfo:(void *)contextInfo {  
    NSString *message;  
    NSString *title;  
	NSLog(@"in imagesavedtophotoalbum loop");
    if (!error) {  
        title = NSLocalizedString(@"SaveSuccessTitle", @"");  
        message = NSLocalizedString(@"SaveSuccessMessage", @"");  
    } else {  
        title = NSLocalizedString(@"SaveFailedTitle", @"");  
        message = [error description];  
    }  
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:title  
                                                    message:message  
                                                   delegate:nil  
                                          cancelButtonTitle:NSLocalizedString(@"ButtonOK", @"")  
                                          otherButtonTitles:nil];  
    [alert show];  
    [alert release];  
}  
/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	
	
	self.locationManager = [[CLLocationManager alloc] init]; 
	
	locationManager.delegate = self;
	locationManager.desiredAccuracy = kCLLocationAccuracyBest; 
	[locationManager startUpdatingLocation];
	
	
	
	UIAccelerometer *accel = [UIAccelerometer sharedAccelerometer];
    accel.delegate = self;
    accel.updateInterval = kUpdateInterval;
	
    [super viewDidLoad];
	
	//check for camera
	BOOL result;
	result = [UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera];
	NSLog(@"Camera: %d", result);
	
	//check for photo library
	result = [UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary];
	NSLog(@"photo library: %d", result);
	
	//check for saved photos album
	result = [UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeSavedPhotosAlbum];
	NSLog(@"saved photos album: %d", result);
}



/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	self.locationManager = nil;
	self.latitudeLabel = nil;
	self.longitudeLabel = nil;
}


- (void)dealloc {
	[locationManager release];

	[latitudeLabel release];
	[longitudeLabel release];
    [super dealloc];
}
#pragma mark - #pragma mark CLLocationManagerDelegate Methods 
- (void)locationManager:(CLLocationManager *)manager
	didUpdateToLocation:(CLLocation *)newLocation 
		   fromLocation:(CLLocation *)oldLocation {

	NSString *latitudeString = [[NSString alloc] initWithFormat:@"Latitude: %g° , Longitude: %g°", newLocation.coordinate.latitude,newLocation.coordinate.longitude];
	//s = [[s autorelease] stringByAppendingString:@"World"];
	//latitudeString = [[latitudeString autorelease]stringByAppendingString:@"World"];
	latitudeLabel.text = latitudeString; 
	[latitudeString release];
	
}


			 
- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error {
	
	NSString *errorType = (error.code == kCLErrorDenied) ? @"Access Denied" : @"Unknown Error";
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error getting Location"
													message:errorType delegate:nil   cancelButtonTitle:@"Okay" otherButtonTitles:nil]; 
	[alert show]; 
	[alert release];
}

#pragma mark -
- (void)accelerometer:(UIAccelerometer *)accelerometer 
        didAccelerate:(UIAcceleration *)acceleration {
    
	NSString *acc = [[NSString alloc] initWithFormat:@"acc: x: %g°, y:%g°, z: %g° ", acceleration.x, acceleration.y, acceleration.z];
	
	//s = [[s autorelease] stringByAppendingString:@"World"];
	//latitudeString = [[latitudeString autorelease]stringByAppendingString:@"World"];
	longitudeLabel.text = acc; 
	[acc release];

}

@end
